#ifndef LOADER_H
#define LOADER_H

#include <string>
#include <vector>

class Image;
class Mesh;

class Loader
{
    static std::string obj_directory;
    static std::string mtl_directory;
    static std::string tex_directory;

public:
    static std::string* loadTextFile(const std::string &filename);
    static Image* loadImage(const std::string &filename, bool hasAlpha = true);
    static std::vector<Mesh*> loadMesh(const std::string &filename);
    static bool loadMTL(const std::string &filename);

    static void setObjDirectory(std::string);
    static void setMtlDirectory(std::string);
    static void setTexDirectory(std::string);
};

#endif // LOADER_H
